<?php
  require __DIR__."/../lib/tlplib.php";
  $tlp = new TlpApi();

  if (isset($_GET["call"])) {
    switch ($_GET["call"]) {
      case "ingest":
        if (isset($_POST["title"]) && isset($_POST["id"]) && isset($_POST["lang"]) && isset($_POST["requested_langs"]) && (isset($_POST["mediaUrl"]) || isset($_FILES["mediaFile"]))) {
          echo $tlp->ingest_new($_POST["title"], $_POST["id"], $_POST["lang"], json_decode($_POST["requested_langs"], true), (isset($_POST["mediaUrl"]) ? $_POST["mediaUrl"] : $_FILES["mediaFile"]), (isset($_FILES["slidesFile"]) ? $_FILES["slidesFile"] : NULL), NULL, NULL);
        }
        else {
          echo json_encode(array("Error" => "Missing input parameters for /ingest call. Please fill in all the required fields."));
        }
        break;
      case "status":
        if (isset($_POST["id"]) && !empty($_POST["id"])) {
          echo $tlp->status($_POST["id"]);
        }
        else {
          echo json_encode(array("Error" => "Missing input parameters for /status call. Please fill in all the required fields."));
        }
        break;
      case "metadata":
        if (isset($_POST["id"]) && !empty($_POST["id"])) {
          echo $tlp->metadata($_POST["id"]);
        }
        else {
          echo json_encode(array("Error" => "Missing input parameters for /metadata call. Please fill in all the required fields."));
        }
        break;
      case "langs":
        if (isset($_POST["id"]) && !empty($_POST["id"])) {
          echo $tlp->langs($_POST["id"]);
        }
        else {
          echo json_encode(array("Error" => "Missing input parameters for /langs call. Please fill in all the required fields."));
        }
        break;
      case "subs":
        if (isset($_POST["id"]) && !empty($_POST["id"]) && isset($_POST["lang"]) && !empty($_POST["lang"])) {
          if (isset($_POST["format"])) echo htmlspecialchars($tlp->subs($_POST["id"], $_POST["lang"], intval($_POST["format"])));
          else echo htmlspecialchars($tlp->subs($_POST["id"], $_POST["lang"]));
        }
        else {
          echo json_encode(array("Error" => "Missing input parameters for /langs call. Please fill in all the required fields."));
        }
        break;
    }
  }
  else {
?>
<html>
<head>
  <script src="//code.jquery.com/jquery-2.1.4.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.4/js/bootstrap.min.js"></script>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.4/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.4/css/bootstrap-theme.min.css">
  <style>
  pre {
    max-height: 380px;
  }
  </style>
</head>
<body style="padding: 1em;">
  <ul class="nav nav-pills nav-justified">
    <li role="presentation" class="active"><a href="#ingest" aria-controls="ingest" role="tab" data-toggle="tab">/ingest</a></li>
    <li role="presentation"><a href="#uploadslist" aria-controls="uploadslist" role="tab" data-toggle="tab">/uploadslist</a></li>
    <li role="presentation"><a href="#status" aria-controls="status" role="tab" data-toggle="tab">/status</a></li>
    <li role="presentation"><a href="#metadata" aria-controls="metadata" role="tab" data-toggle="tab">/metadata</a></li>
    <li role="presentation"><a href="#langs" aria-controls="langs" role="tab" data-toggle="tab">/langs</a></li>
    <li role="presentation"><a href="#subs" aria-controls="subs" role="tab" data-toggle="tab">/subs</a></li>
    <li role="presentation"><a href="#systems" aria-controls="systems" role="tab" data-toggle="tab">/systems</a></li>
  </ul>
  <div class="tab-content" style="margin-top: 1em;">
    <div role="tabpanel" class="tab-pane active" id="ingest">
      <div class="col-md-6">
        <div class="panel panel-default">
          <div class="panel-heading">Input data</div>
          <div class="panel-body">
            <form>
              <div class="form-group">
                <label for="ingest-title">Media title</label>
                <input type="text" class="form-control" id="ingest-title" placeholder="Enter media title">
              </div>
              <div class="form-group">
                <label for="ingest-id">Media ID</label>
                <input type="text" class="form-control" id="ingest-id" placeholder="Enter media ID">
              </div>
              <div class="form-group">
                <label for="ingest-asr-lang">ASR System (media language)</label>
                <select class="form-control" id="ingest-asr-lang">
                  <?php
                    $systems = json_decode($tlp->systems(), true);
                    if (is_array($systems["asr"])) foreach ($systems["asr"] as $sys) echo "<option value=\"".$sys["id"]."\">".$sys["name"]."</option>";
                  ?>
                </select>
              </div>
              <div class="form-group">
                <label for="ingest-mt-langs">MT Systems (translation languages)</label>
                <select type="text" class="form-control" id="ingest-mt-langs" multiple>
                  <?php
                    if (is_array($systems["mt"])) foreach ($systems["mt"] as $sys) echo "<option value=\"".$sys["id"]."\">".$sys["name"]."</option>";
                  ?>
                </select>
              </div>
              <div class="form-group">
                <label class=" control-label" for="ingest-media">Media file:</label>
                <input id="ingest-media-url" name="ingest-media-url" type="text" placeholder="Enter URL (YouTube and Vimeo URLs are supported)" class="form-control">
                <span>or</span><br/>
                <input id="ingest-media-file" class="input-file" type="file">
              </div>
              <div class="form-group">
                <label class="control-label" for="ingest-slides-file">Slides file (optional):</label>
                <input id="ingest-slides-file" class="input-file" type="file">
              </div>
              <button id="ingest-send" type="button" class="btn btn-default"><span class="glyphicon glyphicon-open" aria-hidden="true"></span> Upload</button>
            </form>
          </div>
        </div>
      </div>
      <div class="col-md-6">
        <div class="panel panel-default">
          <div class="panel-heading">Return data</div>
          <div class="panel-body">
          <pre id="ingest-return"></pre>
          </div>
        </div>
      </div>
    </div>
    <div role="tabpanel" class="tab-pane" id="uploadslist">
      <div class="col-md-6">
        <div class="panel panel-default">
          <div class="panel-heading">Input data</div>
          <div class="panel-body">
            None
          </div>
        </div>
      </div>
      <div class="col-md-6">
        <div class="panel panel-default">
          <div class="panel-heading">Return data</div>
          <div class="panel-body">
            <pre><?php echo $tlp->uploadslist(); ?></pre>
          </div>
        </div>
      </div>
    </div>
    <div role="tabpanel" class="tab-pane" id="status">
      <div class="col-md-6">
        <div class="panel panel-default">
          <div class="panel-heading">Input data</div>
          <div class="panel-body">
            <form>
              <div class="form-group">
                <label for="status-upload-id">Upload ID</label>
                <input type="text" class="form-control" id="status-upload-id" placeholder="Enter Upload ID">
              </div>
              <button id="status-send" type="button" class="btn btn-default"><span class="glyphicon glyphicon-send" aria-hidden="true"></span> Retrieve data</button>
            </form>
          </div>
        </div>
      </div>
      <div class="col-md-6">
        <div class="panel panel-default">
          <div class="panel-heading">Return data</div>
          <div class="panel-body">
            <pre id="status-return"></pre>
          </div>
        </div>
      </div>
    </div>
    <div role="tabpanel" class="tab-pane" id="metadata">
      <div class="col-md-6">
        <div class="panel panel-default">
          <div class="panel-heading">Input data</div>
          <div class="panel-body">
            <form>
              <div class="form-group">
                <label for="metadata-id">Media ID</label>
                <input type="text" class="form-control" id="metadata-id" placeholder="Enter Media ID">
              </div>
              <button id="metadata-send" type="button" class="btn btn-default"><span class="glyphicon glyphicon-send" aria-hidden="true"></span> Retrieve data</button>
            </form>
          </div>
        </div>
      </div>
      <div class="col-md-6">
        <div class="panel panel-default">
          <div class="panel-heading">Return data</div>
          <div class="panel-body">
            <pre id="metadata-return"></pre>
          </div>
        </div>
      </div>
    </div>
    <div role="tabpanel" class="tab-pane" id="langs">
      <div class="col-md-6">
        <div class="panel panel-default">
          <div class="panel-heading">Input data</div>
          <div class="panel-body">
            <form>
              <div class="form-group">
                <label for="langs-id">Media ID</label>
                <input type="text" class="form-control" id="langs-id" placeholder="Enter Media ID">
              </div>
              <button id="langs-send" type="button" class="btn btn-default"><span class="glyphicon glyphicon-send" aria-hidden="true"></span> Retrieve data</button>
            </form>
          </div>
        </div>
      </div>
      <div class="col-md-6">
        <div class="panel panel-default">
          <div class="panel-heading">Return data</div>
          <div class="panel-body">
            <pre id="langs-return"></pre>
          </div>
        </div>
      </div>
    </div>
    <div role="tabpanel" class="tab-pane" id="subs">
      <div class="col-md-6">
        <div class="panel panel-default">
          <div class="panel-heading">Input data</div>
          <div class="panel-body">
            <form>
              <div class="form-group">
                <label for="subs-id">Media ID</label>
                <input type="text" class="form-control" id="subs-id" placeholder="Enter Media ID">
              </div>
              <div class="form-group">
                <label for="subs-lang">Captions language code</label>
                <input type="text" class="form-control" id="subs-lang" placeholder="Enter language code">
              </div>
              <div class="form-group">
                <label for="subs-lang">Captions format</label>
                <select class="form-control" id="subs-format"><option value="0">transLectures-extended DFXP format</option><option value="1">Non-extended DFXP format</option><option value="2">SRT format</option><option value="3">WebVTT format</option><option value="4">Plain text</option></select>
              </div>
              <button id="subs-send" type="button" class="btn btn-default"><span class="glyphicon glyphicon-send" aria-hidden="true"></span> Retrieve data</button>
            </form>
          </div>
        </div>
      </div>
      <div class="col-md-6">
        <div class="panel panel-default">
          <div class="panel-heading">Return data</div>
          <div class="panel-body">
            <pre id="subs-return"></pre>
          </div>
        </div>
      </div>
    </div>
    <div role="tabpanel" class="tab-pane" id="systems">
      <div class="col-md-6">
        <div class="panel panel-default">
          <div class="panel-heading">Input data</div>
          <div class="panel-body">
            None
          </div>
        </div>
      </div>
      <div class="col-md-6">
        <div class="panel panel-default">
          <div class="panel-heading">Return data</div>
          <div class="panel-body">
            <pre><?php echo $tlp->systems(); ?></pre>
          </div>
        </div>
      </div>
    </div>
  </div>
</body>
<script>
/* ingest call */
var systems = <?php echo json_encode($systems); ?>;
function get_system_lang(id, type) {
  if (type == "asr")
    for (var i=0; i<systems[type].length; i++) if (systems[type][i]["id"] == id) return systems[type][i]["lang"];
  if (type == "mt")
    for (var i=0; i<systems[type].length; i++) if (systems[type][i]["id"] == id) return systems[type][i]["target_lang"];
}
$('button#ingest-send').click(function() {
  postData = new FormData();
  postData.append("title", $('#ingest-title').val());
  postData.append("id", $('#ingest-id').val());
  postData.append("lang", get_system_lang($('#ingest-asr-lang option:selected').val(), "asr"));
  var requested_langs = {};
  requested_langs[get_system_lang($('#ingest-asr-lang option:selected').val(), "asr")] = {"sub": null};
  $.each($('#ingest-mt-langs option:selected'), function() {
    requested_langs[get_system_lang($(this).val(), "mt")] = {"sub": null};
  });
  postData.append("requested_langs", JSON.stringify(requested_langs));
  if ($('#ingest-media-url').val().length > 0) postData.append("mediaUrl", $('#ingest-media-url').val());
  else postData.append("mediaFile", $('#ingest-media-file').get(0).files[0]);
  if ($('#ingest-slides-file').val().length > 0) postData.append("slidesFile", $('#ingest-slides-file').get(0).files[0]);
  $.ajax({
    type: "POST",
    url: "?call=ingest",
    data: postData,
    cache: false,
    contentType: false,
    processData: false,
    success: function(response) {
      $('#ingest-return').html(JSON.stringify(response));
      $('body').scrollTop('0');
    },
    error: function(e) {
      $('#ingest-return').html("Error: " + JSON.stringify(e));
      $('body').scrollTop('0');
    },
    dataType: "json"
  });
});

/* status call */
$('button#status-send').click(function() {
  var postData = {};
  postData["id"] = $('#status-upload-id').val();
  $.ajax({
    type: "POST",
    url: "?call=status",
    data: postData,
    success: function(response) {
      $('#status-return').html(JSON.stringify(response));
      $('body').scrollTop('0');
    },
    error: function(e) {
      $('#status-return').html("Error: " + JSON.stringify(e));
      $('body').scrollTop('0');
    },
    dataType: "json"
  });
});

/* metadata call */
$('button#metadata-send').click(function() {
  var postData = {};
  postData["id"] = $('#metadata-id').val();
  $.ajax({
    type: "POST",
    url: "?call=metadata",
    data: postData,
    success: function(response) {
      $('#metadata-return').html(JSON.stringify(response));
      $('body').scrollTop('0');
    },
    error: function(e) {
      $('#metadata-return').html("Error: " + JSON.stringify(e));
      $('body').scrollTop('0');
    },
    dataType: "json"
  });
});

/* langs call */
$('button#langs-send').click(function() {
  var postData = {};
  postData["id"] = $('#langs-id').val();
  $.ajax({
    type: "POST",
    url: "?call=langs",
    data: postData,
    success: function(response) {
      $('#langs-return').html(JSON.stringify(response));
      $('body').scrollTop('0');
    },
    error: function(e) {
      $('#langs-return').html("Error: " + JSON.stringify(e));
      $('body').scrollTop('0');
    },
    dataType: "json"
  });
});

/* subs call */
$('button#subs-send').click(function() {
  var postData = {};
  postData["id"] = $('#subs-id').val();
  postData["lang"] = $('#subs-lang').val();
  postData["format"] = $('#subs-format option:selected').val();
  $.ajax({
    type: "POST",
    url: "?call=subs",
    data: postData,
    success: function(response) {
      $('#subs-return').html(response);
      $('body').scrollTop('0');
    },
    error: function(e) {
      $('#subs-return').html("Error: " + JSON.stringify(e));
      $('body').scrollTop('0');
    },
  });
});
</script>
</html>
<?php } ?>
